package de.mhus.lib;

import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

public class MDate {

	private long time = 0;
	private TimeZone tz;

	public MDate(long time, TimeZone tz) {
		this.time = time;
		this.tz = tz;
	}
	
	public MDate() {
		this(null);
	}

	public MDate(Object value) {
		if (value == null) {
			time = System.currentTimeMillis();
			tz   = TimeZone.getDefault();
		} else
		if (value instanceof Calendar) {
			Calendar date = (Calendar)value;
			time = date.getTimeInMillis();
			tz = date.getTimeZone();
		} else
		if (value instanceof Date) {
			Date date = (Date)value;
			time = date.getTime();
			tz   = TimeZone.getDefault();
		} else
		if (value instanceof MDate) {
			MDate date = (MDate)value;
			time = date.getTime();
			tz   = date.getTimeZone();
		} else
		if (value instanceof java.sql.Date) {
			java.sql.Date date = (java.sql.Date)value;
			time = date.getTime();
			tz = TimeZone.getDefault();
		} else {
			String dateString = value.toString();
			Date date = MCast.toDate(dateString,null);
			if (date == null)
				throw new NumberFormatException(dateString);
			time = date.getTime();
			tz   = TimeZone.getDefault();
		}
	}

	public long getTime() {
		return time;
	}

	public TimeZone getTimeZone() {
		return tz;
	}
	
	public Date toDate() {
		return new Date(time);
	}
	
	public Calendar toCalendar() {
		Calendar out = Calendar.getInstance(tz);
		out.setTimeInMillis(time);
		return out;
	}
	
	public String toString() {
		return MCast.toString(toDate());
	}

	public java.sql.Date toSqlDate() {
		return new java.sql.Date(time);
	}
	
}
