package de.mhus.lib;

import java.lang.ref.WeakReference;
import java.util.TimerTask;

import de.mhus.lib.logging.Log;

public class MHousekeeper {
	
	private static Log log = Log.getLog(MHousekeeper.class);
	private MTimer timer;
	
	public MHousekeeper() {
		log.t("new housekeeper");
		timer = new MTimer(true);
	}
	
	public void register(MHousekeeperTask task, long sleep, boolean weak) {
		timer.schedule(new MyTimerTask(task,weak), sleep, sleep);
	}
	
	@Override
	public void finalize() {
		log.t("finalize");
		if (timer != null) timer.cancel();
		timer = null;
	}
	
	private class MyTimerTask extends MTimerTask {

		private WeakReference<TimerTask> refWeak;
		private TimerTask ref;

		public MyTimerTask(TimerTask task, boolean weak) {
			if (weak)
				refWeak = new WeakReference<TimerTask>(task);
			else
				ref = task;
				
		}

		@Override
		public void doit() throws Exception {
			
			TimerTask r = null;
			
			if (refWeak != null)
				r = refWeak.get();
			else
				r = ref;
			
			if (r == null) {
				this.cancel();
				return;
			}
			
			r.run();
		}
		
	}

	public static Log log() {
		return log;
	}
}
