package de.mhus.lib;

import java.util.Properties;
import java.util.Set;

import de.mhus.lib.util.SetCast;

public class MProperties extends IProperties {

	protected Properties properties = null;
	
	public MProperties() {
		this(new Properties());
	}
	
	public MProperties(Properties properties) {
		this.properties = properties;
	}

	@Override
	public Object getProperty(String name) {
		return properties.getProperty(name);
	}

	@Override
	public boolean isProperty(String name) {
		return properties.containsKey(name);
	}

	@Override
	public void removeProperty(String key) {
		properties.remove(key);
	}

	@Override
	public void setProperty(String key, Object value) {
		properties.setProperty(key, MCast.objectToString(value) );
	}

	@Override
	public boolean isEditable() {
		return true;
	}

	@Override
	public Set<String> keys() {
		return new SetCast<Object, String>(properties.keySet());
	}
	
}
