package de.mhus.lib.aao;

import java.util.Set;

import de.mhus.lib.cao.CaoAccess;
import de.mhus.lib.cao.CaoElement;
import de.mhus.lib.cao.CaoException;
import de.mhus.lib.cao.CaoList;
import de.mhus.lib.cao.CaoMetadata;
import de.mhus.lib.cao.CaoWritableElement;

public class ProxyElement extends AaoElement {

	private CaoElement slave;

	protected ProxyElement(AaoElement parent, CaoElement slave) throws CaoException {
		super(parent);
		this.slave = slave;
	}

	@Override
	public CaoList getChildren(CaoAccess access) throws CaoException {
		return new AaoList(this,slave.getChildren());
	}

	@Override
	public boolean isNode() {
		return slave.isNode();
	}

	@Override
	public String getId() throws CaoException {
		return slave.getId();
	}

	@Override
	public String getName() throws CaoException {
		return slave.getName();
	}

	@Override
	public CaoMetadata getMetadata() {
		return slave.getMetadata();
	}

	@Override
	public String getString(String name) throws CaoException {
		return slave.getString(name);
	}

	@Override
	public CaoList getList(String name, CaoAccess access, String... attributes)
			throws CaoException {
		return slave.getList(name, access, attributes);
	}

	@Override
	public Object getObject(String name, String... attributes)
			throws CaoException {
		return slave.getObject(name, attributes);
	}

	@Override
	public boolean isWritable() {
		return slave.isWritable();
	}

	@Override
	public CaoWritableElement getWritableNode() throws CaoException {
		return null;
	}

	@Override
	public void reload() throws CaoException {
		slave.reload();
	}

	@Override
	public boolean lock(int timeout) throws CaoException {
		return slave.lock(timeout);
	}

	@Override
	public boolean unlock() throws CaoException {
		return slave.unlock();
	}

	@Override
	public boolean isLocked(boolean owner) throws CaoException {
		return slave.isLocked(owner);
	}

	@Override
	public boolean isValid() {
		return slave.isValid();
	}

	@Override
	public Set<String> keys() {
		return slave.keys();
	}

}
