package de.mhus.lib.adb.annotations;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Use this to add a list of indexes to a column. Use comma as separator. The simplest way
 * to name the indexes is by numbers. If the index starts with an 'u' the index will be defined
 * as an unique index. Do not name the index to long most database engines have restrictions
 * about the length of an index name.
 * 
 * @author mikehummel
 *
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface DbIndex {

	public static final String UNIQUE = "u";
	
	String value();

}
