package de.mhus.lib.adb.annotations;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import de.mhus.lib.sql.Dialect;

/**
 * Mark a getter or setter with this annotation to define it as a column in the database.
 * DbPrimaryKey will have the same effect. If you mark a getter or setter as persistent
 * both functions getter and setter must exist and be public. Fou boolenas the getter
 * can also have a 'is...' notation.
 * 
 * @author mikehummel
 *
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface DbPersistent {
	int size() default 201;
	String more() default "";
	Dialect.TYPE type() default Dialect.TYPE.UNKNOWN;
	boolean nullable() default true;
	boolean auto_id() default false;
	boolean virtual() default false;
}
