package de.mhus.lib.adb.model;

import de.mhus.lib.adb.DbDynamic;

public class TableDynamic extends Table {

	@Override
	protected void parseFields() throws InstantiationException, IllegalAccessException {
		DbDynamic.Field[] fa = ((DbDynamic)clazz.newInstance()).getFieldDefinitions();
		for (DbDynamic.Field f : fa) {
			
			Field field = manager.getSchema()
				.createField(manager, this, f.getName(), f.isPrimaryKey(), !f.isPersistent(), null, null, f.getReturnType(), f.getAttributes(), f);
			
			if (field != null) addField( field );
			
			// indexes
			String indexes = f.getIndexes();
			if (indexes != null) {
				addToIndex(indexes,field);
			}

		}		
	}

}
