package de.mhus.lib.cao;

import java.util.Iterator;
import java.util.LinkedList;


public class CaoActionForwarder implements IActionProvider, Iterable<IActionProvider> {

	private LinkedList<IActionProvider> customProviders = new LinkedList<IActionProvider>();
	
	@Override
	public void fillWithActions(CaoElement element, CaoList targetList, CaoActionList actionList,
			Object... initConfig) {

		try {
			
			for (IActionProvider custom : customProviders)
				custom.fillWithActions(element, targetList, actionList, initConfig);
			
//			for (CaoElement element : targetList.getElements()) {
//				element.getDriver().fillWithActions(targetList, actionList, initConfig);
//			}
		} catch (Exception e) {}
	}

	public IActionProvider removeFirst() {
		return customProviders.removeFirst();
	}

	public IActionProvider removeLast() {
		return customProviders.removeLast();
	}

	public void addFirst(IActionProvider e) {
		customProviders.addFirst(e);
	}

	public void addLast(IActionProvider e) {
		customProviders.addLast(e);
	}

	public int size() {
		return customProviders.size();
	}

	public boolean add(IActionProvider e) {
		return customProviders.add(e);
	}

	public boolean remove(Object o) {
		return customProviders.remove(o);
	}

	public Iterator<IActionProvider> iterator() {
		return customProviders.iterator();
	}

	public void clear() {
		customProviders.clear();
	}

	public void add(int index, IActionProvider element) {
		customProviders.add(index, element);
	}

	public IActionProvider remove(int index) {
		return customProviders.remove(index);
	}

	public boolean contains(IActionProvider actionProvider) {
		return customProviders.contains(actionProvider);
	}

	
}
