package de.mhus.lib.cao;

import java.util.LinkedList;

public abstract class CaoActionProvider implements IActionProvider {

	protected LinkedList<CaoAction> list = new LinkedList<CaoAction>();
	
	/**
	 * Fill the list with a set of valid actions for this list.
	 * 
	 * @param targetList
	 * @param actionList
	 */
	public void fillWithActions(CaoElement element, CaoList targetList, CaoActionList actionList,Object...initConfig) {
		if (!canExecute(targetList,initConfig)) return;
		
		for (CaoAction action : list) {
			try {
				if (action.canExecute(targetList,initConfig))
					actionList.add(action);
			} catch (Throwable t) {
				//TODO logger
				t.printStackTrace();
			}
		}
		
	}
	
	/**
	 * pre check if the list can be executed by the actions in this set.
	 * E.g check the driver type or connection etc.
	 * @param list
	 * @return
	 */
	protected abstract boolean canExecute(CaoList list,Object...initConfig);
	
}
