package de.mhus.lib.cao;

import de.mhus.lib.config.IConfig;

public abstract class CaoApplication implements IActionProvider {

	private CaoConnection connection;
	private IConfig config;

	protected CaoApplication(CaoConnection connection, IConfig config) throws CaoException {
		this.connection = connection;
		this.config = config;
	}
	
	public final CaoElement queryElement(String name, String ... attributes ) throws CaoException {
		return queryElement(name, null, attributes);
	}
	
	public CaoElement getDefaultTree() throws CaoException {
		return queryElement(CaoDriver.TREE_DEFAULT);
	}
	
	/**
	 * Return the requested element or null.
	 * 
	 * @param name
	 * @param access
	 * @param attributes
	 * @return
	 * @throws CaoException
	 */
	public abstract CaoElement queryElement(String name, CaoAccess access, String ... attributes ) throws CaoException;
	
	public final CaoConnection getConnection() {
		return connection;
	}
	
	/**
	 * Return the configuration or null if not set.
	 * 
	 * @return
	 */
	public IConfig getConfig() {
		return config;
	}
	
	public void fillWithActions(CaoElement element, CaoList targetList, CaoActionList actionList,Object...initConfig) {
		getConnection().fillWithActions(element, targetList, actionList, initConfig);
	}
}
