package de.mhus.lib.cao;

import de.mhus.lib.config.IConfig;
import de.mhus.lib.form.MForm;

public abstract class CaoForm implements MForm {

	private IConfig config;

	/**
	 * Return the configuration as an serialized url.
	 * 
	 * @param secrets If this is true the config should also serialize the secret informations.
	 * 
	 * @return
	 */
	public abstract String toUrl(boolean secrets);

	/**
	 * Init the configuration with the serialized informations from url.
	 * 
	 * @param url
	 * @throws CaoException
	 */
	public abstract void fromUrl(String url) throws CaoException;
	
	public void setConfig(IConfig config) {
		this.config = config;
	}
	
	public synchronized IConfig getConfig() {
		return config;
	}
	
}
