package de.mhus.lib.cao;

public abstract class CaoList {

	private String id;
	protected CaoElement parent;
	
	protected CaoList(CaoElement parent, String id) {
		this.parent = parent;
		this.id = id;
	}

	public final CaoConnection getConnection() {
		return parent.getConnection();
	}
	
	public final CaoApplication getApplication() {
		return parent.getApplication();
	}
	
	public final CaoDriver getDriver() {
		return getConnection().getDriver();
	}

	public String getId() throws CaoException {
		return id;
	}
		
	public abstract CaoMetadata getMetadata();
	
	/**
	 * Return the size of the list or -1 if unknown or not supported.
	 * 
	 * @return
	 */
	public abstract int size();
	
	public abstract CaoListIterator getElements() throws CaoException;

	/**
	 * Returns the parent element if possible.
	 * 
	 * @return null or the parent element.
	 */
	public CaoElement getParent() {
		return parent;
	}
	
}
