package de.mhus.lib.cao.util;

import de.mhus.lib.cao.CaoDriver;
import de.mhus.lib.cao.CaoMetaDefinition;
import de.mhus.lib.cao.CaoMetaDefinition.TYPE;
import de.mhus.lib.cao.CaoMetadata;

public class CombinedMetadata extends CaoMetadata {

	public CombinedMetadata(CaoDriver driver) {
		super(driver);
	}
	
	public void addMetaDefinition(String name, TYPE type, String nls, long size, String ... categories ) {
		for ( CaoMetaDefinition def : definition ) {
			if (def.getName().equals(name)) return;
		}
		definition.add(new CaoMetaDefinition(this,name,type,nls,size,categories));
	}

	public void addMetaDefinitions(CaoMetadata metadata) {
		if (metadata == null) return;
		for ( CaoMetaDefinition def : metadata ) {
			addMetaDefinition(def.getName(), def.getType(), def.getNls(), def.getSize(), def.getCategories());
		}
	}
	

}
