package de.mhus.lib.cao.util;

import de.mhus.lib.cao.CaoAccess;
import de.mhus.lib.cao.CaoApplication;
import de.mhus.lib.cao.CaoConnection;
import de.mhus.lib.cao.CaoElement;
import de.mhus.lib.cao.CaoException;
import de.mhus.lib.config.IConfig;

public class NoneApplication extends CaoApplication {

	private static CaoApplication instance = null;

	public NoneApplication()
	throws CaoException {
		this(NoneConnection.getInstance(), null);
	}
	public NoneApplication(CaoConnection connection, IConfig config)
			throws CaoException {
		super(connection, config);
	}

	@Override
	public CaoElement queryElement(String name, CaoAccess access,
			String... attributes) throws CaoException {
		return null;
	}
	
	public static synchronized CaoApplication getInstance() {
		if (instance == null)
			try {
				instance = new NoneApplication();
			} catch (CaoException e) {
				e.printStackTrace();
			}
		return instance;
	}

}
