package de.mhus.lib.cao.util;

import de.mhus.lib.cao.CaoConnection;
import de.mhus.lib.cao.CaoDriver;
import de.mhus.lib.cao.CaoException;
import de.mhus.lib.cao.CaoUser;
import de.mhus.lib.config.IConfig;

public class NoneConnection extends CaoConnection {

	private static CaoConnection instance = null;

	public NoneConnection() {
		this(NoneDriver.getInstance(), null);
		try {
			setUser( new CaoUser(new EmptyApplication(this),System.getProperty("user.name"),true,false) );
		} catch (CaoException e) {
		}
	}
	
	public NoneConnection(CaoDriver driver, IConfig config) {
		super(driver, config);
	}

	public static synchronized CaoConnection getInstance() {
		if (instance == null)
			instance = new NoneConnection();
		return instance;
	}

	@Override
	protected void doDisconnect() {
	}

	@Override
	public boolean isValid() {
		return true;
	}

}
