package de.mhus.lib.cao.util;

import de.mhus.lib.MSingleton;
import de.mhus.lib.cao.AlreadyInitialized;
import de.mhus.lib.cao.CaoConnection;
import de.mhus.lib.cao.CaoDriver;
import de.mhus.lib.cao.CaoException;
import de.mhus.lib.cao.CaoForm;
import de.mhus.lib.config.IConfig;
import de.mhus.lib.logging.Log;

public class NoneDriver extends CaoDriver {

	private static Log log = Log.getLog(NoneDriver.class);
	private static CaoDriver instance = null;

	
	public NoneDriver() {
		try {
			initialize("none", null, MSingleton.instance().getActivator());
		} catch (AlreadyInitialized e) {
			log.i(e);
		}
	}
	@Override
	public CaoConnection createConnection(String url, IConfig config)
			throws CaoException {
		return new NoneConnection();
	}

	@Override
	public CaoForm createConfiguration() {
		return null;
	}

	@Override
	protected void initDefaultApplications() {
		
	}

	public static synchronized CaoDriver getInstance() {
		if (instance == null)
			instance = new NoneDriver();
		return instance;
	}

}
