package de.mhus.lib.cao.util;

import de.mhus.lib.MActivator;
import de.mhus.lib.cao.CaoAction;
import de.mhus.lib.cao.CaoDriver;
import de.mhus.lib.cao.CaoException;
import de.mhus.lib.cao.CaoList;
import de.mhus.lib.cao.CaoOperation;
import de.mhus.lib.form.MForm;
import de.mhus.lib.logging.Log;

public class SetTargetAction extends CaoAction {

	private static Log log = Log.getLog();
	
	public SetTargetAction(MActivator activator, String resourceName) {
		super(activator, resourceName);
	}

	@Override
	public boolean canExecute(CaoList list, Object... initConfig) {
		try {
			return (list.size() == 1 && list.getElements().next().isNode());
		} catch (CaoException e) {
			log.d(e);
			return false;
		}
	}

	@Override
	public MForm createConfiguration(CaoList list, Object... initConfig)
			throws CaoException {
		return null;
	}

	@Override
	public CaoOperation execute(CaoList list, Object configuration)
			throws CaoException {
		
		CaoClipboard.getClipboard().setTarget( list.getElements().next() );
		return null;
	}

	@Override
	public String getName() {
		return CaoDriver.ACTION_CAP_SET_TARGET;
	}

}
