package de.mhus.lib.cao.util;

import de.mhus.lib.MActivator;
import de.mhus.lib.MSingleton;
import de.mhus.lib.cao.CaoApplication;
import de.mhus.lib.cao.CaoApplicationFactory;
import de.mhus.lib.cao.CaoConnection;
import de.mhus.lib.cao.CaoException;
import de.mhus.lib.cao.CaoForm;
import de.mhus.lib.config.IConfig;

public class SimpleApplicationFactory extends CaoApplicationFactory {

	private MActivator activator;

	public void setActivator(MActivator activator) {
		this.activator = activator;
	}
	
	@Override
	public CaoForm createConfiguration() {
		return null;
	}

	@Override
	protected CaoApplication create(CaoConnection con, IConfig config2)
			throws CaoException {
		try {
			MActivator a = activator;
			if (a==null) a = MSingleton.instance().getActivator();
			String appClass = config.getExtracted("application_class");
			CaoApplication app = (CaoApplication) a.createObject(appClass,new Class[] {CaoConnection.class,IConfig.class}, new Object[] {con,config2});
			return app;
		} catch(Throwable t) {
			throw new CaoException(t);
		}
	}

}
