package de.mhus.lib.cao.util;

import de.mhus.lib.cao.CaoElement;
import de.mhus.lib.cao.CaoException;
import de.mhus.lib.cao.CaoList;
import de.mhus.lib.cao.CaoListIterator;
import de.mhus.lib.cao.CaoMetaDefinition;
import de.mhus.lib.cao.CaoMetaDefinition.TYPE;
import de.mhus.lib.cao.CaoMetadata;

public class StringArrayList extends CaoList {

	private String[] values;
	private CombinedMetadata meta;

	public StringArrayList(CaoElement parent, String id,String[] values,CaoMetaDefinition metad) {
		super(parent, id);
		this.values=values;
		meta = new CombinedMetadata(getDriver());
		meta.addMetaDefinition(metad.getName(), metad.getType(), metad.getNls(), metad.getSize(), metad.getCategories());
		
	}
	public StringArrayList(CaoElement parent, String id,String[] values,String mName, TYPE mType, String mNls, long mSize, String ... mCategories) {
		super(parent, id);
		this.values=values;
		meta = new CombinedMetadata(getDriver());
		meta.addMetaDefinition(mName, mType, mNls, mSize, mCategories);
	}

	@Override
	public CaoMetadata getMetadata() {
		return meta;
	}

	@Override
	public int size() {
		return values.length;
	}

	public String[] getArray() {
		return values;
	}

	private class ListIterator extends CaoListIterator {

		private int index;
		
		protected ListIterator() {
			super(StringArrayList.this.getConnection());
			reset();
		}


		@Override
		protected boolean hasNextElement() {
			return values.length > index;
		}

		@Override
		protected CaoElement nextElement() throws CaoException {
			if ( ! (values.length > index)) return null;
			return new StringElement(getParent(),meta,values[index++]);
		}

		@Override
		public void reset() {
			index = 0;
		}

	}

	@Override
	public CaoListIterator getElements() {
		return new ListIterator();
	}

}
