package de.mhus.lib.cao.util;

import java.util.Set;

import de.mhus.lib.cao.CaoAccess;
import de.mhus.lib.cao.CaoElement;
import de.mhus.lib.cao.CaoException;
import de.mhus.lib.cao.CaoList;
import de.mhus.lib.cao.CaoMetadata;
import de.mhus.lib.cao.CaoWritableElement;
import de.mhus.lib.cao.ObjectNotFoundException;
import de.mhus.lib.util.ArraySet;


public class StringElement extends CaoElement {

	private String value;
	private CaoMetadata meta;

	public StringElement(CaoElement parent,CaoMetadata meta, String value) throws CaoException {
		super(parent);
		this.value = value;
		this.meta = meta;
		
	}

	@Override
	public CaoList getChildren(CaoAccess CaoAccess) throws CaoException {
		throw new ObjectNotFoundException();
	}

	@Override
	public String getId() throws CaoException {
		throw new ObjectNotFoundException();
	}

	@Override
	public CaoList getList(String name, CaoAccess CaoAccess, String... attributes)
			throws CaoException {
		throw new ObjectNotFoundException(name);
	}

	@Override
	public CaoMetadata getMetadata() {
		return meta;
	}

	@Override
	public String getName() throws CaoException {
		return value;
	}

	@Override
	public Object getObject(String name, String... attributes)
			throws CaoException {
		return value;
	}

	@Override
	public String getString(String name) throws CaoException {
		return value;
	}

	@Override
	public CaoWritableElement getWritableNode() throws CaoException {
		return null;
	}

	@Override
	public boolean isLocked(boolean owner) throws CaoException {
		return owner;
	}

	@Override
	public boolean isNode() {
		return false;
	}

	@Override
	public boolean isValid() {
		return true;
	}

	@Override
	public boolean isWritable() {
		return false;
	}

	@Override
	public boolean lock(int timeout) throws CaoException {
		return false;
	}

	@Override
	public void reload() throws CaoException {
	}

	@Override
	public boolean unlock() throws CaoException {
		return false;
	}

	@Override
	public CaoElement getParent() {
		return null;
	}

	@Override
	public boolean isEditable() {
		return false;
	}

	@Override
	public Set<String> keys() {
		return new ArraySet<String>(new String[]{"value"});
	}

}
