package de.mhus.lib.config;

import java.io.File;
import java.io.FileOutputStream;

import de.mhus.lib.MException;
import de.mhus.lib.MFile;

public class JsonConfigFile extends JsonConfig {

	private File file;

	public JsonConfigFile(File file) throws Exception {
		super(MFile.readFile(file));
		this.file = file;
	}
	
	public boolean canSave() {
		return file.canWrite();
	}

	public void save() throws MException {
		try {
			if (!canSave()) return;
			log.t("save config",this);
			FileOutputStream os = new FileOutputStream(file);
			write(os);
			os.close();
		} catch (Exception e) {
			throw new MException(e);
		}
	}
	
	@Override
	public String toString() {
		return getClass() + ": " + file.getAbsolutePath();
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public File getFile() {
		return file;
	}

}
