package de.mhus.lib.config;

import java.util.HashMap;
import java.util.Properties;

import de.mhus.lib.MException;

public class NodeConfig extends PropertiesConfig {
	
	private HashMap<String, IConfig> configurations = new HashMap<String, IConfig>();
	
	public NodeConfig() {
		super(new Properties());
	}
	
	public void setConfig(String name, IConfig config) {
		configurations.put(name, config);
	}
	
	public IConfig getConfig(String key) {
		return configurations.get(key);
	}

	public IConfig[] getConfigBundle(String key) {
		return new IConfig[] { getConfig(key)};
//		return configurations.values().toArray(new IConfig[configurations.size()]);
	}

	public String[] getConfigKeys() {
		return configurations.keySet().toArray(new String[configurations.size()]);
	}

	public IConfig createConfig(String key) throws MException {
		NodeConfig newConfig = new NodeConfig();
		setConfig(key, newConfig);
		return newConfig;
	}

}
