package de.mhus.lib.form;

import de.mhus.lib.MActivator;
import de.mhus.lib.form.annotations.FormElement;
import de.mhus.lib.form.builders.FormModelBuilder;

public class FormBuilder {

	public static MFormModel buildForm(MActivator activator, MForm target, String schema) throws FormException {
		if (target instanceof IConfigurable) {
			return ((IConfigurable) target).getConfigurationForm();
		}
		if (target.getClass().isAnnotationPresent(FormElement.class)) {
			try {
				return new FormModelBuilder(activator, target, schema);
			} catch (Exception e) {
				throw new FormException(target, null, e);
			}
		}
		throw new FormException(target, null, "can't create form");
	}
}
