/*
 *  Copyright (C) 2002-2004 Mike Hummel
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package de.mhus.lib.form;

import de.mhus.lib.form.objects.FObject;

public class FormException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = -8827379905739013364L;

	public FormException(Object target, FObject input) {
		super((input != null ? input.getName() : "<?>" ) + ": ");
	}

	public FormException(Object traget, FObject input, String message,
			Throwable cause) {
		super((input != null ? input.getName() : "<?>" ) + ": " + message, cause);
	}

	public FormException(Object traget, FObject input, String message) {
		super((input != null ? input.getName() : "<?>" ) + ": " + message);
	}

	public FormException(Object traget, FObject input, Throwable cause) {
		super((input != null ? input.getName() : "<?>" ) + ": ", cause);
	}

}
