package de.mhus.lib.form.builders;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import de.mhus.lib.config.XmlConfig;
import de.mhus.lib.form.MFormModel;
import de.mhus.lib.form.objects.FObject;

public class FormLayoutSimpleBuilder extends FormLayoutBuilder {

	public FormLayoutSimpleBuilder(MFormModel model) throws ParserConfigurationException {
		super(model);
		
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		Document doc = factory.newDocumentBuilder().newDocument();
		Element root = doc.createElement("layout");
		doc.appendChild(root);		
		
		for ( FObject object : model.getSortedList() ) {
			Element element = doc.createElement("element");
			root.appendChild(element);
			element.setAttribute("element", object.getName());
			element.setAttribute("type", "field");
		}

		load(new XmlConfig(root),this.root);
	}

}
