package de.mhus.lib.form.layout;

import de.mhus.lib.MString;
import de.mhus.lib.form.objects.FObject;

/**
 * Represent a field in the form. This is a direct reference to the model object.
 * @author mikehummel
 *
 */
public class LField extends LObject {

	private FObject[] object;

	public LField() {
	}
	
	public FObject[] getObjects() {
		return object;
	}
	
	@Override
	public String getTitle() {
		String out = config.getExtracted("title");
		if (out == null && object.length > 0) return object[0].findTitle();
		return model.getNls().find(out);
	}

	public void init() {
		String[] id = MString.split(config.getString("element",""), ",");
		object = new FObject[id.length];
		for (int i = 0; i < object.length; i++)
			object[i] = model.getElement(id[i]);
	}

}
