package de.mhus.lib.form.objects;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import de.mhus.lib.form.FormException;
import de.mhus.lib.form.ValidateException;

public class FEMail extends FString {

	private static final String EMAIL_PATTERN = 
        "^[_A-Za-z0-9-]+(\\.[_A-Za-z0-9-]+)*@[A-Za-z0-9]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$";
	private Pattern pattern;


	public FEMail() {
		pattern = Pattern.compile(EMAIL_PATTERN);
	}
	
	public void setValue(String value) throws FormException {
		if (value == null)
			value = "";

		Matcher matcher = pattern.matcher(value);
		if (!matcher.matches())
			throw new ValidateException(getTarget(), this, "format");
		
		super.setValue(value);
	}
}
