/*
 *  Copyright (C) 2002-2004 Mike Hummel
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package de.mhus.lib.form.objects;

import java.util.LinkedList;

/**
 * Used to show a file chooser element. The file must not exist or can be null
 * or empty if no file is selected. The path is set as string. See FString for
 * details.
 * 
 * TODO Add extension support and directory / file select
 * 
 * @author mike
 * 
 */
public class FFile extends FString {

	public static enum MODI {
		FILES_ONLY, DIRECTORIES_ONLY
		/* , FILES_AND_DIRECTORIES */
	};

	private LinkedList<Filter> filters = new LinkedList<Filter>();
	private MODI mode = MODI.FILES_ONLY;
	private boolean selectMultiple = false;

	public LinkedList<Filter> getFilter() {
		return filters;
	}

	public void setSelectMode(MODI pMode) {
		mode = pMode;
	}

	public void setSelectMultiple(boolean in) {
		selectMultiple = in;
	}

	public static class Filter {
		protected String ext;
		protected String desc;

		public Filter(String extension, String description) {
			ext = extension;
			desc = description;
		}
	}

	public MODI getSelectMode() {
		return mode;
	}

	public boolean isSelectMultiple() {
		return selectMultiple;
	}

}
