/*
 *  Copyright (C) 2002-2004 Mike Hummel
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package de.mhus.lib.form.objects;

public class FTree extends FString {

	private ITreeProvider dataProvider;

	public Node[] getChildren(String id) {
		initDataProvider();
		
		return dataProvider.getChildren( id );
	}

	public static class Node {

		public Node(String id, String title, boolean isLeaf, boolean selectable) {
			this.id = id;
			this.title = title;
			this.isLeaf = isLeaf;
			this.selectable = selectable;
		}

		public String title;
		public String id;
		public boolean selectable = true;
		public boolean isLeaf = false;
	}

	public String[] getPathToId(String id) {
		initDataProvider();
		return dataProvider.getPath(id);
	}
	
	protected void initDataProvider() {
		if ( dataProvider != null ) {
			try {
				dataProvider = (ITreeProvider)getForm().getTarget().getClass().getMethod(
						"get" + getNameAsMethodSuffix() + "DataProvider", new Class[] {})
						.invoke(getForm().getTarget(), new Object[] {});
				
			} catch (Throwable e) {
				log().w(getName(),e);
			}
		}
	}
	
}
