package de.mhus.lib.form.objects;

import java.util.LinkedList;

public class SimpleDynTableProvider implements IDynTableProvider {

	public String[] titles = new String[0];
	public LinkedList<String[]> rows = new LinkedList<String[]>();
	public String[] defaultRow = new String[0];
	
	@Override
	public String[] getTitles() {
		return titles;
	}

	@Override
	public int getRowCount() {
		return rows.size();
	}

	@Override
	public String[] getRow(int r) {
		return normalizeRow(rows.get(r));
	}

	@Override
	public int getColumnCount() {
		return titles.length;
	}

	@Override
	public void setData(String[][] data) {
		rows.clear();
		if (data == null) return;
		for (String[] row : data) {
			row = normalizeRow(row);
			rows.add(row);
		}
	}

	public String[] normalizeRow(String[] row) {
		if (row == null) row = defaultRow.clone();
		if (row.length != titles.length) {
			String[] rowNew = new String[titles.length];
			for (int i = 0; i < rowNew.length; i++)
				if (row.length < i)
					rowNew[i] = row[i];
				else
					rowNew[i] = "";
			row = rowNew;
		} else {
			for (int i = 0; i < row.length; i++)
				if (row[i] == null)
					row[i] = "";
		}
		return row;
	}
	
	@Override
	public String[] getDefaultRow() {
		return normalizeRow(defaultRow);
	}

}
