package de.mhus.lib.form.ui;


import de.mhus.lib.form.FormException;
import de.mhus.lib.form.layout.LField;
import de.mhus.lib.form.objects.FObject;
import de.mhus.lib.lang.MObject;

public abstract class UiInput extends MObject {
	
	protected UiModel control;
	protected LField field;
	protected UiModelBuilder builder;

	public final void initialize(LField field, UiModelBuilder builder) {
		this.field = field;
		this.builder = builder;
		this.control = builder.getModel();
		this.control.getElements().add(this); // register itself
		doInit();
	}

	protected abstract void doInit();

	/**
	 * Got Value from fomular - please show it in the UI!
	 * @throws FormException
	 */
	public abstract void getValue() throws FormException;

	/**
	 * Please set the UI value to the formular model.
	 * @throws FormException
	 */
	public abstract void setValue() throws FormException;
	
	public abstract void dispose();
	
	public String toString() {
		StringBuffer out = new StringBuffer();
		out.append('{').append(field.getTitle()).append(':');
		if (field != null && field.getObjects() != null) {
			for (FObject obj : field.getObjects()) {
				out.append('[').append(obj).append(']');
			}
		}
		out.append('}');
		return out.toString();
	}
}
