/*
 *  Copyright (C) 2002-2004 Mike Hummel
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package de.mhus.lib.io;

import java.io.IOException;
import java.io.OutputStream;

public class SizeCountOutputStream extends OutputStream {

	private long count;
	private OutputStream stream;

	public SizeCountOutputStream(OutputStream stream) {
		this.stream = stream;
	}

	@Override
	public void write(int b) throws IOException {
		count++;
		stream.write(b);
	}

	public long getSize() {
		return count;
	}

	public void close() throws IOException {
		stream.close();
	}

	public void flush() throws IOException {
		stream.flush();
	}

}
