package de.mhus.lib.parser;

import de.mhus.lib.MCast;
import de.mhus.lib.MDate;
import de.mhus.lib.MSql;
import de.mhus.lib.MString;
import de.mhus.lib.sql.parser.FunctionPart;
import de.mhus.lib.sql.parser.ICompiler;
import de.mhus.lib.sql.parser.ParameterPart;

public class SimpleQueryCompiler extends StringCompiler implements ICompiler {
	
//	private static Log log = Log.getLog(SimpleQueryCompiler.class);
	
	protected StringPart createDefaultAttributePart(String part) {
		ParameterPart out = new ParameterPart(this);
		out.attribute = MString.split(part,",");
		return out;
	}

	@Override
	public boolean isParseAttributes() {
		return true;
	}

	@Override
	public ParsingPart compileFunction(FunctionPart function) {
		return function;
	}

	@Override
	public String toSqlDateValue(MDate string) {
		return "'" + MCast.toString(string) + "'";
	}

	@Override
	public String valueToString(Object value) {
		return MCast.objectToString(value);
	}

	@Override
	public String escape(String text) {
		return MSql.escape(text);
	}

	
}