package de.mhus.lib.parser;

import java.io.IOException;

public abstract class StringParsingPart implements ParsingPart {
	
	@Override
	public void parse(ParseReader str) throws ParseException {
		doPreParse();
		
		try {
			while( !str.isClosed() ) {
				char c = str.character();
				boolean res = parse(c,str);
				if (!res) {
					doPostParse();
					return;
				}
			}
		} catch (IOException e) {
			throw new ParseException(e);
		}
		
		doPostParse();

	}

	public abstract void doPreParse();

	public abstract void doPostParse();

	public abstract boolean parse(char c,ParseReader str) throws ParseException, IOException;

}
