package de.mhus.lib.persistence;

import java.io.File;

import de.mhus.lib.config.IConfig;
import de.mhus.lib.jmx.JmxManaged;
import de.mhus.lib.jmx.MJmx;

@JmxManaged(descrition = "Application Persistence Scope")
public abstract class Scope extends MJmx {

	/**
	 * Return a config file for the name. This feature is a
	 * must support.
	 * 
	 * @param name
	 * @return
	 */
	public abstract IConfig getPersistence(String name);
	
	/**
	 * Return a file for the given name or null if this is not
	 * supported. The files will not be flushed from the persistence manager.
	 * 
	 * @param name
	 * @return
	 */
	public abstract File getPersistenceFile(String name);
	
	/**
	 * Return true if it's possible to use persistence files.
	 * 
	 * @return
	 */
	@JmxManaged
	public abstract boolean isPersistenceFile();
	
	/**
	 * 
	 */
	@JmxManaged
	public abstract String[] getPersistenceNames();
	
	/**
	 * 
	 */
	@JmxManaged
	public abstract String[] getPersistenceFileNames();
	
	@JmxManaged
	public abstract String getSessionId();
	
}
