package de.mhus.lib.resources;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;

import de.mhus.lib.MActivator;
import de.mhus.lib.MSingleton;

public class ActivatorResourceProvider implements IResourceProvider {

	private MActivator loader;

	public ActivatorResourceProvider() {
		loader = MSingleton.instance().getActivator();
	}
	
	public ActivatorResourceProvider(MActivator loader) {
		this.loader = loader;
	}
	
	public OutputStream createFile(String path) throws IOException {
		throw new IOException("Access denied: " + path );
	}

	public InputStream getInputStream(String path) throws IOException {
		try {
			return loader.getResource(path);
		} catch (Exception e) {
			throw new IOException(e);
		}
	}

	public long getLastModified(String path) throws IOException {
		return 0;
	}

	public boolean isWriteable(String path) {
		return false;
	}

	@Override
	public URL getResource(String path) {
		return loader.getURL(path);
	}

}
