package de.mhus.lib.resources;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;

public class ClasspathResourceProvider implements IResourceProvider {

	private ClassLoader loader;

	public ClasspathResourceProvider() {
		loader = this.getClass().getClassLoader();
	}
	
	public ClasspathResourceProvider(ClassLoader loader) {
		this.loader = loader;
	}
	
	public OutputStream createFile(String path) throws IOException {
		throw new IOException("Access denied: " + path );
	}

	public InputStream getInputStream(String path) throws IOException {
		return loader.getResourceAsStream(path);
	}

	public long getLastModified(String path) throws IOException {
		return 0;
	}

	public boolean isWriteable(String path) {
		return false;
	}

	@Override
	public URL getResource(String path) {
		return loader.getResource(path);
	}

}
