package de.mhus.lib.resources;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;

public interface IResourceProvider {

	/**
	 * Return the last modified time or 0 if not supported.
	 * 
	 * @param path
	 * @return
	 * @throws IOException
	 */
	public long getLastModified(String path) throws IOException;

	public InputStream getInputStream(String path) throws IOException;

	public boolean isWriteable(String path);

	public OutputStream createFile(String path) throws IOException;

	public URL getResource(String path) throws IOException;

}
