/*
 *  Copyright (C) 2002-2004 Mike Hummel
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package de.mhus.lib.resources;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Hashtable;

import de.mhus.lib.logging.Log;

public class MResources {

	public static final String DEFAULT_PROVIDER = "";
	private static Log log = Log.getLog(MResources.class);
	
	private Hashtable<String, IResourceProvider> dataProvider = new Hashtable<String, IResourceProvider>();
	
	public MResources() {
//		registerProvider("mhu", new MhuResourceProvider() );
	}
		
	public void registerProvider( String name, IResourceProvider provider ) {
		log.debug( "Register provider: " + name + "," + provider.getClass() );
		dataProvider.put( name, provider );
	}
	
	public void unregisterProvider(String name) {
		log.debug( "Unregister provider: " + name );
		dataProvider.remove(name);
	}
	
	public IResourceProvider getProvider(String path) {
		if ( path == null ) return null; 
		if ( path.indexOf(':') > 0 )
			return dataProvider.get(path.substring(0,path.indexOf(':')));
		else
			return dataProvider.get(DEFAULT_PROVIDER);
	}
	
	public String getLocalPath(String path) {
		if ( path == null ) return null; 
		if ( path.indexOf(':') > 0 )
			return path.substring( path.indexOf(':')+1 );
		else
			return path;
	}

	public URL getResource(String path) {

		return null;

	}

	public Object createObject(String clazz) throws InstantiationException,
			IllegalAccessException, ClassNotFoundException {
		return createClass(clazz).newInstance();
	}

	public Class<?> createClass(String clazz) throws ClassNotFoundException {
		return Class.forName(clazz);
	}
	
	public InputStream getInputStream(String path) throws IOException {
		IResourceProvider provider = getProvider(path);
		if (provider == null) return null;
		return provider.getInputStream(getLocalPath(path));
	}

//	public ResourceBdl getResourceBundle(String path) {
//		try {
//
//			// return new ResourceBdl(ResourceBundle.getBundle(name)); //TODO
//			IResourceProvider provider = getProvider(path);
//			String localPath = getLocalPath(path);
//			provider.getInputStream(path);
//			
//		} catch (Exception e) {
//			if (log.t())
//				log.info("ResourceBundle not found for: " + path);
//		}
//		return null;
//	}
//
//	public ResourceBdl getResourceBundle(Class name) {
//		String path = name.getCanonicalName();
//		if (name.isMemberClass())
//			path = path.substring(0, path.lastIndexOf('.'));
//		return getResourceBundle(path);
//	}
	// TODO

}
