package de.mhus.lib.resources;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;

public class PathResourceProvider implements IResourceProvider {

	private File dir;
	
	public PathResourceProvider(File base) {
		dir = base;
	}
	
	public long getLastModified(String path) throws IOException {
		return new File(dir,path).lastModified();
	}
	
	public InputStream getInputStream(String path) throws IOException {
		return new FileInputStream( new File(dir,path) );
	}

	public OutputStream createFile(String path) throws IOException {
		return new FileOutputStream( new File( dir, path ));
	}

	public boolean isWriteable(String path) {
		return new File(dir,path).canWrite();
	}

	@Override
	public URL getResource(String path) throws IOException {
		return new File(dir,path).toURI().toURL();
	}

}
