package de.mhus.lib.resources;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.util.zip.ZipEntry;
import java.util.zip.ZipException;
import java.util.zip.ZipFile;

public class ZipResourceProvider implements IResourceProvider {

	private ZipFile zipFile;
	private File file;

	public ZipResourceProvider(File file) throws ZipException, IOException {
		this.file = file;
		zipFile = new ZipFile(file);
	}
	
	public long getLastModified(String path) throws IOException {
		return zipFile.getEntry(path).getTime();
	}

	public InputStream getInputStream(String path) throws IOException {
		ZipEntry entry = zipFile.getEntry(path);
		if (entry == null) return null;
		return zipFile.getInputStream( entry );
	}

	public boolean isWriteable(String path) {
		return false;
	}

	public OutputStream createFile(String path) throws IOException {
		return null;
	}

	@Override
	public URL getResource(String path) throws IOException {
		URL url = new URL("jar", "", -1, "file://" + file.getAbsolutePath() + "!/" + path);

		//try {
			if (url.openConnection().getContentLength() < 0) return null;
		//} catch (IOException ioe) {}
		
		return url;
	}
	
}
