package de.mhus.lib.sql;

import java.text.SimpleDateFormat;

import de.mhus.lib.MDate;
import de.mhus.lib.MSql;

/**
 * This class can compare a configuration with a database table structure
 * and can modify the database structure without deleting existing tables.
 * 
 * TODO: on request: remove other columns
 * TODO: views, foreign keys
 * TODO: data !!!
 * @author mikehummel
 *
 */
public class DialectMysql extends DialectDefault {
	
	public String normalizeColumnName(String columnName) {
//		if ("key".equals(columnName))
//			return "key_";
//		return columnName;
		return columnName + "_"; // TODO not working at all
	}
	
	public String getDbType(String type, String size) {
		String t = type.toUpperCase();
		
		
		if (t.equals(TYPE.FLOAT.name())) {
			t = "DOUBLE"; // Float is too small - use double
		} else
		if (t.equals(TYPE.BLOB.name())) {
			t = "LONGBLOB"; // blob is too small - use longblob 
		} else
			return super.getDbType(t, size);
		
		return t;
	}
	
	private static SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	@Override
	public String toSqlDateValue(MDate date) {
		synchronized (dateFormat) {
			return "'" + dateFormat.format(date.toDate() ) + "'";
		}
	}

	@Override
	public String escape(String text) {
		String ret = MSql.escape(text);
		if (ret == null || text == null) return ret;
		if (ret.indexOf('\\') < 0)
			return ret;
		return ret.replaceAll("\\\\", "\\\\\\\\");
	}

}
