package de.mhus.lib.sql.commonparser;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;

import de.mhus.lib.MXml;
import de.mhus.lib.parser.CompiledString;
import de.mhus.lib.parser.ParseException;
import de.mhus.lib.parser.Parser;
import de.mhus.lib.parser.StringPart;
import de.mhus.lib.sql.parser.ICompiler;

/**
 
<common>
 <select>
    <from></from>
 	<where></where>
 </select>
</common>
 
 */
public class Common2SqlCompiler implements Parser {

	private ICompiler compiler;

	public Common2SqlCompiler(ICompiler compiler) {
		this.compiler = compiler;
	}
	
	@Override
	public CompiledString compileString(String in) throws ParseException {
		try {
			Document xml = MXml.loadXml(in);
			
			Element rootElement = xml.getDocumentElement();
			if (!rootElement.getNodeName().equals("common"))
				throw new ParseException("xml is not in common language, need to start with the tag <common>",in);
			
			
			
			return new CompiledString(new StringPart[] {});
		} catch (Exception e) {
			throw new ParseException(in,e);
		}
	}

}
